// Generated by CoffeeScript 1.10.0
(function() {
  var _, clone, digit, mask, normalize, typeNames;

  _ = require('lodash');

  normalize = require('./normalize');

  typeNames = ['boolean', 'city', 'credential', 'date', 'email', 'first_name', 'gender', 'last_name', 'number', 'phone', 'postal_code', 'range', 'ssn', 'state', 'string', 'time', 'url'];

  module.exports = {};

  module.exports.names = typeNames;

  typeNames.forEach(function(name) {
    return module.exports[name] = require("./" + (name.replace('_', '-')));
  });

  digit = /^\d+$/;

  module.exports.normalize = normalize;

  module.exports.parse = function(name, value, req) {
    var ref, type;
    if (typeNames.indexOf(name) !== -1) {
      type = module.exports[name];
    }
    if ((type != null) && (value != null)) {
      if (((ref = type.components) != null ? ref.length : void 0) && (value.valid != null)) {
        return value;
      } else {
        return type.parse(value, req);
      }
    } else {
      return value;
    }
  };

  module.exports.mask = mask = function(obj, doMask) {
    var key, str, value;
    if (doMask == null) {
      doMask = false;
    }
    if (obj == null) {
      return obj;
    }
    if (obj instanceof Array) {
      obj = obj.map(function(i) {
        return mask(i, doMask);
      });
    } else if (typeof obj === 'object') {
      if (obj.masked === false && (obj instanceof String || obj instanceof Boolean || obj instanceof Number || obj instanceof Date)) {
        str = new String(mask(obj.toString(), true));
        for (key in obj) {
          value = obj[key];
          if (key === 'valid') {
            continue;
          }
          if (!key.match(digit)) {
            str[key] = mask(value, true);
          }
        }
        str.masked = true;
        obj = str;
      } else {
        for (key in obj) {
          value = obj[key];
          if (key === 'valid') {
            continue;
          }
          obj[key] = mask(value, (obj.masked != null) || doMask);
        }
        if (obj.masked != null) {
          obj.masked = true;
        }
      }
    } else if (_.isString(obj) || _.isNumber(obj) || _.isDate(obj)) {
      if (doMask) {
        obj = obj.toString().replace(/./g, '*');
      }
    } else if (_.isBoolean(obj)) {
      if (doMask) {
        obj = '*';
      }
    } else if (_.isFunction(obj)) {
      void 0;
    } else {
      throw "Don't know how to mask " + obj;
    }
    return obj;
  };

  clone = function(vars) {
    var name, obj, str, value;
    if (_.isArray(vars)) {
      return vars.map(function(v) {
        return clone(v);
      });
    } else if (vars instanceof String) {
      str = new String(vars.toString());
      for (name in vars) {
        value = vars[name];
        if (!name.match(digit)) {
          str[name] = value;
        }
      }
      return str;
    } else if (vars instanceof Number || vars instanceof Boolean || vars instanceof Date) {
      obj = new vars.constructor(vars.valueOf());
      for (name in vars) {
        value = vars[name];
        obj[name] = value;
      }
      return obj;
    } else if (_.isNumber(vars) || _.isBoolean(vars)) {
      return vars.valueOf();
    } else if (_.isDate(vars)) {
      return new Date(vars.getTime());
    } else if (_.isFunction(vars)) {
      return vars;
    } else if (vars instanceof Object) {
      obj = {};
      for (name in vars) {
        value = vars[name];
        obj[name] = clone(value);
      }
      return obj;
    } else {
      return vars;
    }
  };

  module.exports.clone = clone;

  module.exports.isValid = function(value) {
    if (!_.isPlainObject(value)) {
      return true;
    }
  };

}).call(this);
